#' @title Generic function for coefficient names
#' @description Generic function for names of parameter estimates of object of class "fastCUB".
#' @aliases parnames.fastCUB
#' @param object An object of class "fastCUB"
#' @import methods
#' @return Parameter names
#' @keywords internal
#' @seealso \code{\link{summary}}

parnames <- function(object) UseMethod("parnames", object)





parnames.fastCUB<-function(object){


  covpai<-  object$covpai #object$env$covpai  #model.matrix(effe,data=mf,rhs=1)
  covcsi<- object$covcsi # object$env$covcsi #model.matrix(effe,data=mf,rhs=2)


  if (NCOL(covpai)==0){
    Y<-NULL
  } else {

    if (NCOL(covpai)==2){
      Y<-as.matrix(covpai[,-1])
    #  colnames(Y)<-colnames(covpai)[2]
    } else {
      Y<-covpai[,-1]
    }
  }
  if (NCOL(covcsi)==0){
    W<-NULL
  } else {
    if (NCOL(covcsi)==2){
      W<-as.matrix(covcsi[,-1])
     # colnames(W)<-colnames(covcsi)[2]
    } else {
      W<-covcsi[,-1]
    }
  }
  
  # if (!is.null(Y)){
  #   Y<-as.matrix(Y)
  #   p<-NCOL(Y)
  #   if (p>0){
  #     if (is.null(colnames(Y))){
  #       colnames(Y)<-rep(NA,p)
  #       for (h in 1:p){
  #         colnames(Y)[h]<-paste("Y",h,sep="_")
  #       }
  #     }
  #   }
  # }
  # if (!is.null(W)){
  #   W<-as.matrix(W)
  #   q<-NCOL(W)
  #   if (q>0){
  #     if (is.null(colnames(W))){
  #       colnames(W)<-rep(NA,q)
  #       for (h in 1:q){
  #         colnames(W)[h]<-paste("W",h,sep="_")
  #       }
  #     }
  #   }
  # }
  
  
  



  ellipsis<-object$ellipsis
  listanomi<-c()

    if (is.null(Y) & is.null(W)){
      listanomi<-c("pai","csi")
    }
     if (!is.null(Y) & is.null(W)){
      betacoef<-c()
      npar<-NCOL(Y) #length(object$estimates)
      if (!is.null(colnames(Y))){
        betacoef<-c("intercept",colnames(Y))
      } else {
        betacoef[1]<-"intercept"
       for (j in 2:(npar+1)){
        betacoef[j]<-paste("Y",j-1,sep="_")
       }
      }
       listanomi<-c(betacoef,"csi")
     }

    if (is.null(Y) & !is.null(W)){
      gamacoef<-c()
      npar<-NCOL(W) #length(object$estimates)

      if (!is.null(colnames(W))){
        gamacoef<-c("intercept",colnames(W))
      } else {
        gamacoef[1]<-"intercept"
        for (j in 2:(npar+1)){
          gamacoef[j]<-paste("W",j-1,sep="_")
        }
      }

      listanomi<-c("pai",gamacoef)
    }

    if (!is.null(Y) & !is.null(W)) {
      betacoef<-gamacoef<-c()
      Y<-as.matrix(Y); W<-as.matrix(W)
      ny<-NCOL(Y); nw<-NCOL(W);

      if (is.null(colnames(Y))){
        betacoef[1]<-"intercept"
        for (j in 2:(ny+1)){
          betacoef[j]<-paste("Y",j-1,sep="_")
        }

        } else {
          betacoef<-c("intercept",colnames(Y))
        }



      if (is.null(colnames(W))){
        gamacoef[1]<-"intercept"
        for (j in 2:(nw+1)){
          gamacoef[j]<-paste("W",j-1,sep="_")
        }

      } else {
        gamacoef<-c("intercept",colnames(W))

      }

      listanomi<-c(betacoef,gamacoef)
    }
  return(listanomi)
}

